/***********************************************************************/
/*                                                                     */
/*  FILE        :Analog_drv.c                                          */
/*  DATE        :Wed, Sep 03, 2009                                     */
/*  DESCRIPTION :Analog Function		                               */
/*  CPU TYPE    :H8SX/1653                                             */
/*                                                                     */
/*  Created		:Yoshikazu Morita (d:Frontia)                          */
/*  Modified	:DA8bit->10bit H8SX/1653->H8SX/1655  2010/05/09        */
/***********************************************************************/
#include "iodefine.h"
#include "Analog_Drv.h"

#ifdef __cplusplus
extern "C" {
#endif
extern void Analog_Initalize(void);
#ifdef __cplusplus
}
#endif

//w~b҂
void WaitTime(int time)
{
	P2.DR.BIT.B6 =1;
	while( time -- > 0 )
	{
	
		// 10usec𐳊mɒ~(IVXR[vŌvj
		// 
		__asm{
			push.w		r0			// 6 A
			mov.w		#22,r0		// 4 A
		waitLoop:					
			dec.w		#1,r0		// 2 B
			and.w		r0,r0		// 2 B
			bne			waitLoop	// 4 B
			pop.w		r0			// 6 A
		}
	}
	P2.DR.BIT.B6 =0;
}


//AiOH̏
void Analog_Initalize(void)
{
	//DAAADW[𓮍삳B
	MSTP.CRA.BIT._DA 	= 0;	//ԂDAW[͒~ĂB
	MSTP.CRA.BIT._AD 	= 0;	//ԂADW[͒~ĂB
	
	
	//DA|[g^ɁAnCCs[^XԂ0VɂB
	DA.DADR01T.BYTE     = 0;	// ʂQbit̓]
	DA.DADR0H  			= 0;	// DA0=0
	DA.DADR01T.BYTE     = 0;	// ʂQbit̓]
	DA.DADR1H  			= 0;	// DA1=0
	DA.DACR01.BIT.DAOE1	= 1;	// DA1o
	DA.DACR01.BIT.DAOE0	= 1;	// DA0o
	DA.DACR01.BIT.DAE	= 1;	// `lOCPDAϊ
	

	//AD|[g̓͂~B
	AD.ADCSR.BIT.ADF	= 0;	// A/DGhtO
	AD.ADCSR.BIT.ADIE	= 0;	// ADI荞݂֎~
	AD.ADCSR.BIT.ADST	= 0;	// A/Dϊ~
	AD.ADCSR.BIT.EXCKS  = 1;	// A/DgNbNZNg
	AD.ADCSR.BIT.CH		= 1;	// AN0,AN1AiO͂B
	AD.ADCR.BIT.TRGS	= 0;	// OgK[B
	AD.ADCR.BIT.SCANE	= 1;	// XL[h
	AD.ADCR.BIT.SCANS	= 0;	// 4`l
	AD.ADCR.BIT.CKS		= 3;	// őϊ=49Xe[g 
	
	
	//PortEԌvp̃v[uo͂ƂB
	P2.DDR = 0x0FF;	
}

//AiOḦA̓
//vIbDA1,vVceInDA0Ɋ|A
//vWait[ms]҂āA
//vICAD1,vVceOutAD0͂B
void Analog_Proc( int vDA1, int vDA0,int vWait,int vFlag, int * vAD1,int * vAD0 )
{
	unsigned char work;
	
	P2.DR.BIT.B7 = 1;	//PE.7 AiO	
	
	//DȀo͂ݒ肷BH8SX/1655́A10bitϊĂB
	work = vDA0 << 6;	//DADR01T 7bit 6bitڂɁAOɉ2bit𑗂10bitƂď
	DA.DADR01T.BYTE = work; 
	work = vDA0 >> 2;
	DA.DADR0H = work;
	
	work = vDA1 << 6;	//DADR01T 7bit 6bitڂɁAOɉ2bit𑗂10bitƂď
	DA.DADR01T.BYTE = work;
	work = vDA1 >> 2;
	DA.DADR1H = work;
	
	WaitTime( vWait );		// w莞Ԓ~BimSecP)
	
	//AD̓͂JnB
	AD.ADCSR.BIT.ADF  = 0;	// A/DϊItOZbg
	AD.ADCSR.BIT.ADST = 1;	// A/DϊJn
	while( AD.ADCSR.BIT.ADF == 0 );	// A/DϊI҂ [vӁI
	AD.ADCSR.BIT.ADST = 0;	// A/DϊI
	
	*vAD0 = AD.ADDRA >> 6;	// AD0̓ǂݍ(16bit10bitɒli[ĂBj
	*vAD1 = AD.ADDRB >> 6;	// AD1̓ǂݍ(16bit10bitɒli[ĂBj
	
	//FlagBit0ONł΁AʓdԂێBiLu[Vׁ̈j
	if(( vFlag & 0x01) == 0)
	{
		//vIDȀo͂0ɂB
		//Hi-Zׂɂďo͋֎~ɂ͂ȂB
		DA.DADR01T.BYTE = 0;
		DA.DADR0H = 0x1b;
		
		DA.DADR01T.BYTE = 0;
		DA.DADR1H = 0x1b;
	}
	P2.DR.BIT.B7 = 0;	// PE.7 AiOI
}
